//---------------------------------------------------------------------------
// jrdebug_compilerspecifics.h
// compiler specific symbol defines
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// TO TEST NON-WINDOWS BUILD ON WINDOWS
//#define JrDebugDIRECTIVE_PretendNonWindows
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// PLATFORM
#ifdef WIN32
 #ifndef _WIN32
  #define _WIN32
 #endif
#endif
#ifdef WINDOWS
 #ifndef _WIN32
  #define _WIN32
 #endif
#endif
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// we use our OWN _WIN32JRD flag so we can disable it for testing
#ifdef _WIN32
  #ifndef JrDebugDIRECTIVE_PretendNonWindows
    #define _WIN32JRD
  #endif
#endif
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// kludge for mingw (and other? see http://stackoverflow.com/questions/1549123/how-to-use-the-windows-api-in-mingw)
#ifdef _WIN32JRD
  #ifndef _WIN32_IE
    #define _WIN32_IE 0x0400
  #endif
#endif
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// turn on or off debugging based on JrDebugDIRECTIVE_ObeyNDEBUG?
// this checks common system compilation flags to detect whether app is
//  being compiled in debug mode, and enables jrdebug iff it is.

// Metroworks Codewarrior is brain dead (this kludge is by Ray DeGennaro from usenet)
#ifdef __MWERKS__
 #if __option(sym) 
   #if __ide_target("Debug Win32 x86") 
    #define __DEBUG__ 
   #endif 
 #elif defined(__DEBUG__) 
  //#error "Debugging is off but __DEBUG__ is still defined somewhere!" 
 #endif
#endif
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// try to guess (unless user specifically says not too)
#ifndef JrDebugDIRECTIVE_DontUseSnprintfUnderscores
	#ifdef _MSC_VER
		#define JrDebugDIRECTIVE_UseSnprintfUnderscores
	#endif
	#ifdef __BORLANDC__
		#define JrDebugDIRECTIVE_UseSnprintfUnderscores
	#endif
	#ifdef __DMC__
		#define JrDebugDIRECTIVE_UseSnprintfUnderscores
	#endif
#endif
//---------------------------------------------------------------------------





//--------------------------------------------------------------------------
// different compilers use different macros for current function (sad,sad,sad)
// we now call using all 3 of these in order to work on all compilers

/*
// ATTN: attempt to specifically fix certain compilers
#ifdef __ghs__
 // handle greenhill's c
#else
 #ifdef _MSC_VER
  // visual c++
  #if _MSC_VER <= 1200
   // this is MS Visual C++ 6 or below, which doesn't support __func__ of any kind?
  #endif
 #endif
#endif
*/

// make sure each of these 3 is definted to "" if system doesnt provide it
#ifndef __FUNCTION__
 #define __FUNCTION__ ""
#endif
#ifndef __func__
 #define __func__ ""
#endif
#ifndef __FUNC__
 #define __FUNC__ ""
#endif
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// some dont provide timestamp (thankfully this doesnt seem as broken as FUNC)
#ifndef __TIMESTAMP__
 #ifndef __DATE__
  #define __TIMESTAMP__ ""
 #else
  #define __TIMESTAMP__ __DATE__
 #endif
#endif
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// Borland C++ does not work well with our windows stdout window redirect fix
// ATTN: i've only verified we need this on c++ builder, so im not sure if the free commandline compiler needs it, though i suspect it will
#ifdef __BORLANDC__
	#ifndef __JrDebugDIRECTIVE_ForceFixWin32Console__
    #define JrDebugDIRECTIVE_DontFixWin32Console
	#endif
#endif
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// for Borland C++ Builder (later than v4) we would like to add a helper to let us stream AnsiString classes
// we let user block it by defining JrDebugDIRECTIVE_DontAddAnsiStringStreaming in case they want to add their own
#ifdef __BORLANDC__
	#ifdef __BORLANDC__ > 0x550
		#ifndef JrDebugDIRECTIVE_DontAddAnsiStringStreaming
			#include "vcl.h"
			#include <ostream>
			ostream & operator << (ostream &os, AnsiString s)
				{
				os << s.c_str();
				return os;
				}
		#endif
	#endif
#endif
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
#ifdef _WIN32JRD
	//---------------------------------------------------------------------------
	// this is for windows only (windows.h is included above)
	#define OutputDebugStringDoOutput OutputDebugString
	#define WindowsMessage(X,Y) MessageBox(NULL,X,Y,0)
	//---------------------------------------------------------------------------
#else
	//---------------------------------------------------------------------------
	// ATTN: this is for windows code, needs to be fixed for others
	#define OutputDebugStringDoOutput(str) fprintf(stderr,"%s",str)
	#define WindowsMessage(X,Y) ;
	//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// ATTN: 11/13/10
// put this in some platform conditional area later, for now it works fine on all platforms
#define DEF_DirectorySeparatorString "/"
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// Warning pragmas
#if( defined( _MSC_VER ) )
	//#pragma warning( disable:4068 )			// Disable "unknown pragma" warning for "pragma unused".
	//#pragma warning( disable:4127 )			// Disable "conditional expression is constant" warning for debug macros.
	#pragma warning( disable:4311 )			// Disable "type cast : pointer truncation from void *const to int". (used in jrdebug_output.h windows console code)
#endif
//---------------------------------------------------------------------------
